﻿using Microsoft.LightSwitch;
using Microsoft.LightSwitch.Framework.Client;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace XamTreeLibrary
{
    public partial class XamTreeControl : UserControl
    {
        public XamTreeControl()
        {
            InitializeComponent();
        }
    }

    public class EntityCollectionValueConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            IEntityObject entity = value as IEntityObject;

            string sourcePropertyName = parameter as string;

            var entities = new ObservableCollection<IEntityObject>();
            var temporaryEntities = new List<IEntityObject>();

            entity.Details.Dispatcher.BeginInvoke(delegate
            {
                IEntityCollection eCollection = entity.Details.Properties[sourcePropertyName].Value as IEntityCollection;
                if (eCollection == null)
                    return;

                foreach (IEntityObject e in eCollection)
                {
                    temporaryEntities.Add(e);
                }

                Microsoft.LightSwitch.Threading.Dispatchers.Main.BeginInvoke(delegate
                {
                    foreach (IEntityObject e in temporaryEntities)
                        entities.Add(e);
                });
            });

            return entities;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
